let table;

function preload() {
    table = loadTable( 
      	"https://gist.githubusercontent.com/olga-kondr/2c975a32d6a845b91212698ec27ac85f/raw/79e63548e6f28bd660efc901b71ecd0eb9cb16be/br_for_all_groups.csv",
        "csv", 
        "header"
    );
}

function setup() {
    createCanvas(800, 500);
    background(240);
}

function draw() {
  noStroke();
  fill(150, 150, 150);
  textSize(16);
  text('Birth Rates per 1000 in California.', 260, 20);
  textSize(12);

  counterRows = table.getRowCount();
  let dict = {};
  for (let k = 0; k < counterRows; k++) {
    let val = table.getNum(k, 0);
    if (val in dict) {
      let temp = dict[val];//.push(table.getNum(k, 1));
      temp.push(table.getNum(k, 2));
      dict[val] = temp.sort(function(a, b) {return a - b;});
    }else{
      dict[val] = [table.getNum(k, 2)];
    }
  }
  let resDict = {}, midInd, dataLen, midVal, first, third;
  
  for (const [key, value] of Object.entries(dict)) {
    dataLen = value.length;
    midInd = dataLen / 2;
    midVal = (value[midInd-1] + value[midInd]) / 2;
    first = (value[0] + value[1]) / 2;
    third = (value[4] + value[5]) / 2;
    resDict[key] = [value[0], first, midVal, third, value[dataLen-1]];
  }
  // console.log(resDict);
  const keys = Object.keys(resDict);
  let lenRes = keys.length;
  
  stroke(color(190, 190, 190));
  let step = 20, temp, x, y1, y2, y3, y4;
  for (let i = 0; i < 7; i++) {
    stroke(color(220, 235, 242));
    line(100, 350-i*50, 750, 350-i*50);
    stroke(color(190, 190, 190));
    fill(150, 150, 150);
    noStroke();
    textAlign(RIGHT);
    text(step*(i+1), 80, 350-50*i);
    textAlign(LEFT);
    text(keys[i], 110+i*40, 430);
    stroke(color(190, 190, 190));
  }
  
  for (let i=0; i<lenRes; i++) {
    noStroke();
    fill(150, 150, 150);
    text(keys[i], 110+i*40, 430);
    stroke(color(190, 190, 190));
    // [value[0], first, midVal, third, value[dataLen-1]];
    temp = resDict[keys[i]];
    x = 120+i*40;
    fill(66, 191, 245);
    stroke(color(135, 137, 138));
    rect(x-10, 400-(temp[1]*50/step + (temp[3]-temp[1])*50/step), 20, (temp[3]-temp[1])*50/step);
    strokeWeight(3);
    stroke(color(93, 96, 97));
    line(x-10, 400-(temp[2]*50/step), x+10, 400-(temp[2]*50/step));
    strokeWeight(1);
    stroke(color(135, 137, 138));
    line(x, 400-temp[0]*50/step, x, 400-temp[1]*50/step);
    line(x, 400-temp[3]*50/step, x, 400-temp[4]*50/step);
  }
  
  noStroke();
  push();
  let axisy = radians(270);
  translate(20, 180);
  rotate(axisy);
  textSize(16);
  fill(150, 150, 150);
  text('Birth Rate per 1000', -50, 10);
  textSize(12);
  pop();
  
  noStroke();
  textSize(16);
  fill(150, 150, 150);
  text('Year', 360, 470);
  textSize(12);

  stroke(color(0, 0, 0));
  line(100, 400, 100, 45)
  line(100, 400, 750, 400);
  noStroke();
  textAlign(RIGHT);
  text('0', 80, 400);
  textAlign(LEFT);
}
